com.beaglebuddy.id3.v24.frame_body

## Class ID3v24FrameBodyEventTimingCodes

- java.lang.Object
- - com.beaglebuddy.util.Utility
  - - com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBodyUtility
    - - com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBody
      - - com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBodyEventTimingCodes

-     public class ID3v24FrameBodyEventTimingCodes
      extends ID3v24FrameBody

  An event timing codes frame body is associated with an ID3v2.4 `ETCO` `frame` which is used to synchronize key events in a song. The event timing codes frame body contains the following fields:

  Event Timing Codes Frame Body Fields
  | Field | Description
  --- | --- | ---
  1. | `time stamp format` | `units` of the time stamp field in the `event codes` field.
  2. | eventCodes | list of `events`.

  There may be only one event timing codes frame in an ID3v2.4 `tag`.

  See Also:
    `ID3v24Frame`, ID3 tag version 2.4.0 standard, wikipedia history of ID3 tags

- - ### Field Summary

    - ### Fields inherited from class com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBody

      `buffer, dirty, frameType`

    - ### Fields inherited from class com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBodyUtility

      `nextNullTerminatorIndex, nullTerminatorIndex`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ID3v24FrameBodyEventTimingCodes()` The default constructor is called when creating a new frame.
    `ID3v24FrameBodyEventTimingCodes(java.io.InputStream inputStream, int frameBodySize)` This constructor is called when reading in an existing frame from an .mp3 file.
    `ID3v24FrameBodyEventTimingCodes(TimeStampFormat timeStampFormat, java.util.List<EventCode> eventCodes)` This constructor is called when creating a new frame.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.List<EventCode>` | `getEventCodes()` gets the list of events and the time when they occurred in the .mp3 song.
    `TimeStampFormat` | `getTimeStampFormat()` get the time stamp format.
    `void` | `parse()` parses the raw bytes of the frame body and stores the parsed values in the frame's fields.
    `void` | `setBuffer()` If the frame body's values have been modified, then resize the raw binary buffer and store the new values there.
    `void` | `setEventCodes(java.util.List<EventCode> eventCodes)` sets the list of events and the time when they occurred in the .mp3 song.
    `void` | `setTimeStampFormat(TimeStampFormat timeStampFormat)` sets the time stamp format.
    `java.lang.String` | `toString()` gets a string representation of the event timing codes frame body showing all of the frame's fields and their values.

    - ### Methods inherited from class com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBody

      `getFrameType, getNextNullTerminator, getSize, isDirty, save, save`

    - ### Methods inherited from class com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBodyUtility

      `getNextNullTerminator, pricesToString, stringToBytes`

    - ### Methods inherited from class com.beaglebuddy.util.Utility

      `bytesToInt, bytesToInt, bytesToShort, bytesToShort, bytesToSynchsafeInt, bytesToSynchsafeShort, formateDate, hex, hex, hex, intToBytes, littleEndianBytesToInt, pad, shortToBytes, synchsafeIntToBytes`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ID3v24FrameBodyEventTimingCodes

          public ID3v24FrameBodyEventTimingCodes()

      The default constructor is called when creating a new frame. The default values used are:
      - time stamp format in milliseconds
      - no event codes

    - #### ID3v24FrameBodyEventTimingCodes

          public ID3v24FrameBodyEventTimingCodes(TimeStampFormat timeStampFormat,
                                         java.util.List<EventCode> eventCodes)

      This constructor is called when creating a new frame.
      Parameters:
        `timeStampFormat` - units of the time stamp.
        `eventCodes` - list of event codes.

    - #### ID3v24FrameBodyEventTimingCodes

          public ID3v24FrameBodyEventTimingCodes(java.io.InputStream inputStream,
                                         int frameBodySize)
                                          throws java.io.IOException

      This constructor is called when reading in an existing frame from an .mp3 file. This is then followed by a call to the parse() method.
      Parameters:
        `inputStream` - input stream pointing to an event timing codes frame body in the .mp3 file.
        `frameBodySize` - size (in bytes) of the frame's body.
      Throws:
        `java.io.IOException` - if there is an error while reading the frame body.

  - ### Method Detail

    - #### parse

          public void parse()
                     throws java.lang.IllegalArgumentException

      parses the raw bytes of the frame body and stores the parsed values in the frame's fields.
      Overrides:
        `parse` in class `ID3v24FrameBody`
      Throws:
        `java.lang.IllegalArgumentException` - if an invalid value is detected while parsing the frame body's raw bytes.

    - #### getTimeStampFormat

          public TimeStampFormat getTimeStampFormat()

      get the time stamp format.
      Returns:
        the time stamp format.
      See Also:
        `setTimeStampFormat(TimeStampFormat)`

    - #### setTimeStampFormat

          public void setTimeStampFormat(TimeStampFormat timeStampFormat)

      sets the time stamp format.
      Parameters:
        `timeStampFormat` - the units of the time stamp.
      See Also:
        `getTimeStampFormat()`

    - #### getEventCodes

          public java.util.List<EventCode> getEventCodes()

      gets the list of events and the time when they occurred in the .mp3 song.
      Returns:
        the list of events and the time when they occurred in the .mp3 song.
      See Also:
        `setEventCodes(List)`

    - #### setEventCodes

          public void setEventCodes(java.util.List<EventCode> eventCodes)

      sets the list of events and the time when they occurred in the .mp3 song.
      Parameters:
        `eventCodes` - list of events and the time when they occurred in the .mp3 song.
      See Also:
        `getEventCodes()`

    - #### setBuffer

          public void setBuffer()

      If the frame body's values have been modified, then resize the raw binary buffer and store the new values there. When finished, the dirty flag is reset to indicate that the buffer is up to date, and the frame is now ready to be saved to the .mp3 file.
      Overrides:
        `setBuffer` in class `ID3v24FrameBody`

    - #### toString

          public java.lang.String toString()

      gets a string representation of the event timing codes frame body showing all of the frame's fields and their values.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string representation of the frame body.